<?php namespace EscapeWork\Manager\Models;

use EscapeWork\Manager\Extensions\Collections\PageCollection;
use EscapeWork\LaravelHelpers\BaseModel;
use EscapeWork\LaravelHelpers\SluggableTrait;

class Page extends BaseModel
{

    /**
     * Table
     */
    protected $table = 'manager_pages';

    /**
     * Sluggable
     */
    use SluggableTrait;

    /**
     * Fillable fields
     */
    public $fillable = array(
        'id',
        'title',
        'slug',
        'specific_permissions',
    );

    public function actions()
    {
        return $this->hasMany('EscapeWork\Manager\Models\PageAction');
    }

    public function newCollection(array $models = array())
    {
        return new PageCollection($models);
    }

    public static function seed($data)
    {
        $model  = new static;
        $traits = class_uses($model);

        if (in_array('Illuminate\Database\Eloquent\SoftDeletingTrait', $traits)) {
             if ($existing = static::withTrashed()->where('slug', '=', $data['slug'])->first()) {
                $model = $existing;
             }
        } else {
            if ($existing = static::where('slug', '=', $data['slug'])->first()) {
                $model = $existing;
             }
        }

        $model->fill($data);
        $model->save();
    }
}
